$regfile = "m8def.dat"
$crystal = 4000000

Dim Tryb As Byte , Licznik As Byte , Flaga As Bit , Plus As Bit , Minus As Bit
Dim Sekundy As Byte , Minuty As Byte , Godziny As Byte , Licznik_wyjscia As Byte
Dim Pomoc_sw As Word , Power_on As Bit , Licznik_on As Byte , Wartosc_bcd As Byte
Dim Napiecie As Word , Prad As Word , 6v As Bit , 12v As Bit , 24v As Bit , Blad As Bit
Dim Pojemnosc As Single , Pojemnosc_zadana As Single , Prad_suma As Single
Dim U As Single , Mi As Word , I As Single , Pojemnosc_zm As Single , Pojemnosc_pwm As Single , Pwm1_b As Word
Dim X As Single , Xx As Byte , Y As Word
Dim Flaga_ma_a As Bit

Deflcdchar 0 , 1 , 1 , 3 , 2 , 2 , 3 , 1 , 1                ' replace ? with number (0-7)
Deflcdchar 1 , 31 , 32 , 32 , 32 , 32 , 32 , 32 , 31        ' replace ? with number (0-7)
Deflcdchar 2 , 16 , 16 , 16 , 16 , 16 , 16 , 16 , 16        ' replace ? with number (0-7)
Deflcdchar 3 , 31 , 32 , 14 , 14 , 14 , 14 , 32 , 31        ' replace ? with number (0-7)

Const Rx = 4.8128                                           'obliczy za wzoru

'Config Portb.1 = Output                                     'pwm1a wywietlacz
'Config Portb.2 = Output                                     'pwm1b prd
Config Portc.4 = Input                                      'impulsator
Config Portc.5 = Input                                      'impulsator
Config Portd.0 = Output                                     'przekanik
Config Portd.1 = Input                                      'SW impulsatora
Config Portd.2 = Input                                      'polaryzacja
Config Portd.3 = Input                                      'polaryzacja
Config Portd.4 = Input                                      'termik
Config Portd.5 = Input                                      'wolne
Config Portd.6 = Input                                      'wolne
Config Portd.7 = Input                                      'wolne

Portc.4 = 1                                                 'rezystory na impulsator
Portc.5 = 1                                                 'rezystory na impulsator
Portd.0 = 0                                                 'przekanik wyczony
Portd.1 = 1                                                 'rezystory na SW impulsatora
Portd.2 = 1
Portd.3 = 1
Portd.4 = 1                                                 'rezystor na termik
Portd.5 = 1                                                 'wolne podcignite
Portd.6 = 1                                                 'wolne podcignite
Portd.7 = 1                                                 'wolne podcignite

Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portc.0 , Db5 = Portb.3 , Db6 = Portb.4 , Db7 = Portb.5 , E = Portc.2 , Rs = Portb.0

Config Watchdog = 2048

Config Timer0 = Timer , Prescale = 64

Config Timer1 = Pwm , Prescale = 8 , Pwm = 10 , Compare A Pwm = Clear Down , Compare B Pwm = Clear Down

Config Adc = Single , Prescaler = 128 , Reference = Avcc

Enable Interrupts

Enable Timer0

On Timer0 Przerwanie

Cursor Off

Start Timer0

Start Watchdog

Start Adc

Timer0 = 6

Do

  If Flaga = 1 Then
     If Power_on = 1 Then
        Display On
        Pwm1a = 512

        Select Case Licznik_on
          Case 1:
            Portd.0 = 0                                     'wycz przekanik
            Pwm1b = 0                                       'prd zerowy

          Case 2:
            If Pind.2 = 1 And Pind.3 = 1 Then               'akumulator odczony
               Licznik_on = 1                               'dalej program nie pujdzie zatrzyma si
               Portd.0 = 0                                  'wycz przekanik
               Cls
               Locate 1 , 5
                Lcd "Podlacz"
               Locate 2 , 3
                Lcd "akumulator!"
            End If
            If Pind.2 = 0 And Pind.3 = 0 Then               'awaria detektora
               Licznik_on = 1                               'dalej program nie pujdzie zatrzyma si
               Portd.0 = 0                                  'wycz przekanik
               Cls
               Locate 1 , 5
                Lcd "Detektor"
               Locate 2 , 4
                Lcd "uszkodzony"
            End If
            If Pind.2 = 1 And Pind.3 = 0 Then               'odwrotna polaryzacja
               Licznik_on = 1                               'dalej program nie pujdzie zatrzyma si
               Portd.0 = 0                                  'wycz przekanik
               Cls
               Locate 1 , 7
                Lcd "Zla"
               Locate 2 , 3
                Lcd "polaryzacja"
            End If
            If Pind.2 = 0 And Pind.3 = 1 Then               'prawidowo podcony
               Licznik_on = 3                               'program idzie dalej
            End If

          Case 4:
            Portd.0 = 1                                     'wcz przekanik a potem pomiar napicia akumulatora

          Case 6:                                           'po 2sekundach pomiar napicia
            Napiecie = Getadc(3)                            'identyfikacja napicia akumulatora mierzonego
            If Napiecie > 147 And Napiecie < 165 Then       'od 6 do 6,5v akumulator 6v
               Set 6v
               Reset 12v
               Reset 24v
               Reset Blad
            End If
            If Napiecie > 295 And Napiecie < 330 Then       'od 12v do 13v akumulator 12v
               Reset 6v
               Set 12v
               Reset 24v
               Reset Blad
            End If
            If Napiecie > 590 And Napiecie < 660 Then       'od 24v do 26v akumulator 24v
               Reset 6v
               Reset 12v
               Set 24v
               Reset Blad
            End If
            If Napiecie < 147 Or Napiecie > 660 Then Set Blad       'z poza zakresw ustaw flag bdu
            If Napiecie > 165 And Napiecie < 295 Then Set Blad
            If Napiecie > 330 And Napiecie < 590 Then Set Blad
            If Blad = 1 Then                                'z poza zakresu napie
               Licznik_on = 1                               'detekcja od nowa
               Cls
               Locate 1 , 4                                 'wyswietl komunikat
                Lcd "Napiecie z"
               Locate 2 , 3
                Lcd "poza zakresu"
            Else                                            'gdy odczytano napicie prawidowe
               Cls
               Locate 1 , 3
                Lcd "Naladowany w"
               Locate 2 , 1
                If 6v = 1 Then Lcd "6V"
                If 12v = 1 Then Lcd "12V"
                If 24v = 1 Then Lcd "24V"

                If 6v = 1 Then
                   Y = Napiecie - 147
                   X = Y * 75
                   Xx = Int(x)                              'wycignij liczb cakowit
                   If Xx > 100 Then Xx = 100
                   Locate 2 , 6
                    Lcd Chr(0)
                     If Xx < 25 Then : Lcd Chr(1) : Lcd Chr(1) : Lcd Chr(1) : Lcd Chr(1) : End If       'rysuj grafik pustej baterji
                     If Xx => 25 And Xx < 50 Then : Lcd Chr(3) : Lcd Chr(1) : Lcd Chr(1) : Lcd Chr(1) : End If       '25%
                     If Xx => 50 And Xx < 75 Then : Lcd Chr(3) : Lcd Chr(3) : Lcd Chr(1) : Lcd Chr(1) : End If       '50%
                     If Xx => 75 And Xx < 100 Then : Lcd Chr(3) : Lcd Chr(3) : Lcd Chr(3) : Lcd Chr(1) : End If       '75%
                     If Xx => 100 Then : Lcd Chr(3) : Lcd Chr(3) : Lcd Chr(3) : Lcd Chr(3) : End If       'rysuj grafik penej baterji
                   Locate 2 , 11
                    Lcd Chr(2)
                  Locate 2 , 13
                   Lcd ; Xx ; "%"                           'stopie naadowania w liczbach calkowitych
                End If
                If 12v = 1 Then
                   Y = Napiecie - 294
                   X = Y * 37.5
                   Xx = Int(x)                              'wycignij liczb cakowit
                   If Xx > 100 Then Xx = 100
                   Locate 2 , 6
                    Lcd Chr(0)
                     If Xx < 25 Then : Lcd Chr(1) : Lcd Chr(1) : Lcd Chr(1) : Lcd Chr(1) : End If       'rysuj grafik pustej baterji
                     If Xx => 25 And Xx < 50 Then : Lcd Chr(3) : Lcd Chr(1) : Lcd Chr(1) : Lcd Chr(1) : End If       '25%
                     If Xx => 50 And Xx < 75 Then : Lcd Chr(3) : Lcd Chr(3) : Lcd Chr(1) : Lcd Chr(1) : End If       '50%
                     If Xx => 75 And Xx < 100 Then : Lcd Chr(3) : Lcd Chr(3) : Lcd Chr(3) : Lcd Chr(1) : End If       '75%
                     If Xx => 100 Then : Lcd Chr(3) : Lcd Chr(3) : Lcd Chr(3) : Lcd Chr(3) : End If       'rysuj grafik penej baterji
                   Locate 2 , 11
                    Lcd Chr(2)
                  Locate 2 , 13
                   Lcd ; Xx ; "%"                           'stopie naadowania w liczbach calkowitych
                End If
                If 24v = 1 Then
                   Y = Napiecie - 588
                   X = Y * 18.75
                   Xx = Int(x)                              'wycignij liczb cakowit
                   If Xx > 100 Then Xx = 100
                   Locate 2 , 6
                    Lcd Chr(0)
                     If Xx < 25 Then : Lcd Chr(1) : Lcd Chr(1) : Lcd Chr(1) : Lcd Chr(1) : End If       'rysuj grafik pustej baterji
                     If Xx => 25 And Xx < 50 Then : Lcd Chr(3) : Lcd Chr(1) : Lcd Chr(1) : Lcd Chr(1) : End If       '25%
                     If Xx => 50 And Xx < 75 Then : Lcd Chr(3) : Lcd Chr(3) : Lcd Chr(1) : Lcd Chr(1) : End If       '50%
                     If Xx => 75 And Xx < 100 Then : Lcd Chr(3) : Lcd Chr(3) : Lcd Chr(3) : Lcd Chr(1) : End If       '75%
                     If Xx => 100 Then : Lcd Chr(3) : Lcd Chr(3) : Lcd Chr(3) : Lcd Chr(3) : End If       'rysuj grafik penej baterji
                   Locate 2 , 11
                    Lcd Chr(2)
                  Locate 2 , 13
                   Lcd ; Xx ; "%"                           'stopie naadowania w liczbach calkowitych
                End If
            End If

          Case 12:
            If Pojemnosc < Pojemnosc_zadana Then
               If Plus = 1 Then
                  Licznik_on = 11
                  Licznik_wyjscia = 0
                  If Pojemnosc =< 9.9 Then
                     Set Flaga_ma_a                         'ustaw flag aby wynik wywietla w mA
                     Pojemnosc = Pojemnosc + 0.1
                  Else
                     Reset Flaga_ma_a                       'zeruj flag aby wynik wywietli w A
                     Pojemnosc = Pojemnosc + 1.0
                  End If
               End If
            End If
            If Pojemnosc > 0.9 Then
               If Minus = 1 Then
                  Licznik_on = 11
                  Licznik_wyjscia = 0
                  If Pojemnosc =< 10.1 Then
                     Set Flaga_ma_a                         'ustaw flag aby wynik wywietla w mA
                     Pojemnosc = Pojemnosc - 0.1
                  Else
                     Reset Flaga_ma_a                       'zeruj flag aby wynik wywietli w A
                     Pojemnosc = Pojemnosc - 1.0
                  End If
               End If
            End If
            Cls
            Locate 1 , 3
             Lcd "Pojemnosc ?"
            Locate 2 , 1
             If 6v = 1 Then
                Pojemnosc_zadana = 199
                Lcd "6V / " ; Fusing(pojemnosc , "#.#") ; "Ah"
             End If
             If 12v = 1 Then
                Pojemnosc_zadana = 99
                Lcd "12V / " ; Fusing(pojemnosc , "#.#") ; "Ah"
             End If
             If 24v = 1 Then
                Pojemnosc_zadana = 49
                Lcd "24V / " ; Fusing(pojemnosc , "#.#") ; "Ah"
             End If
             If Pojemnosc < 1.0 Then
                Licznik_on = 11
                Licznik_wyjscia = 0                         'nie ustawiono pojemnoci zeruj licznik i nie przechodz dalej
             Else
                Incr Licznik_wyjscia                        'po 20 obiegach ptli idz dalej
                If Licznik_wyjscia > 8 Then
                   Licznik_wyjscia = 9
                   Licznik_on = 15
                Else
                   Licznik_on = 11
                End If
             End If

             Pojemnosc_pwm = Pojemnosc * Rx                 'dobra w zalerznoci od rozrzutu parametrw rezystorw pomiarowych
             Pwm1_b = Int(pojemnosc_pwm)                    'zwru warto cakowit i wpisz do generatora pwm

          Case 16:                                          'po 5 sekundach wywietlania pojemnoci zadanej
            Cls
            Locate 1 , 3
             Lcd "Rozpoczynam"
            Locate 2 , 6
             Lcd "pomiar"

          Case 21:
            Sekundy = 0                                     'kasuj liczniki czasu rozadowania akumulatora
            Minuty = 0
            Godziny = 0
            Prad_suma = 0

          Case 22:                                          'po 5 sekundach wywietlenia powiadomienia
            Prad = Getadc(1)
            Napiecie = Getadc(3)
            U = Napiecie / 25
            Mi = Prad * 10                                  'prd w mA
            I = Prad / 100                                  'prd w A
            Cls
              Locate 1 , 1
               If Napiecie < 125 And Prad = 0 Then Licznik_on = 0       'gdy akumulator zostanie odczony zacznij wszystko od nowa
               If 6v = 1 Then
                  Lcd "6V"                                  'gdy akumulator zostanie rozadowany przejdz do kolejnej instrukcj wyboru
                  If Napiecie < 132 Then : Licznik_on = 23 : Else : Licznik_on = 21 : End If       'zosta w tej instrukcji wyboru
               End If
               If 12v = 1 Then
                  Lcd "12V"                                 'gdy akumulator zostanie rozadowany przejdz do kolejnej instrukcj wyboru
                  If Napiecie < 265 Then : Licznik_on = 23 : Else : Licznik_on = 21 : End If       'zosta w tej instrukcji wyboru
               End If
               If 24v = 1 Then
                  Lcd "24V"                                 'gdy akumulator zostanie rozadowany przejdz do kolejnej instrukcj wyboru
                  If Napiecie < 530 Then : Licznik_on = 23 : Else : Licznik_on = 21 : End If       'zosta w tej instrukcji wyboru
               End If
            If Pind.4 = 0 Then 'kontrola czujnika temperatury radiatora
               Prad_suma = Prad_suma + Prad                 'sumowanie prdu
               Pwm1b = Pwm1_b                               'wpisz warto prdu do generatora pwm
               Locate 1 , 9                                 'wywietla parametry czas oraz napicie i prd rozadowania
              Wartosc_bcd = Makebcd(godziny)
               Lcd Bcd(wartosc_bcd) ; ":"
              Wartosc_bcd = Makebcd(minuty)
               Lcd Bcd(wartosc_bcd) ; ":"
              Wartosc_bcd = Makebcd(sekundy)
               Lcd Bcd(wartosc_bcd) ;
              Locate 2 , 1
               Lcd "U=" ; Fusing(u , "#.#") ; "V"
              If Flaga_ma_a = 0 Then                        'flaga nie jest ustawiona wynik w A
                 Locate 2 , 10
                  Lcd "I=" ; Fusing(i , "#.#") ; "A"
              Else                                          'flaga ustawiona wynik w mA
                 Locate 2 , 9
                  Lcd "I=" ; Mi ; "mA"                      'bez formatowania wynik w liczbach cakowitych
              End If
            Else                                            'radiatr przegrzany
              Cls
              Locate 1 , 4
               Lcd "Przegrzany"
              Pwm1b = 0                                     'prd zerowy gdy radiator zosta przegrzany
            End If

          Case 24:
            Pojemnosc_zm = Prad_suma / 360000               'obliczenie pojemnoci akumulatora
            Portd.0 = 0                                     'wycz przekanik
            Pwm1b = 0                                       'prd zarowy

          Case 26:
            Cls
            Locate 1 , 1
             Lcd "Pojemnosc wynosi"
            Locate 2 , 4
             Lcd "Q=" ; Fusing(pojemnosc_zm , "#.##") ; "Ah"
            Licznik_on = 25
        End Select
        Incr Licznik_on                                     'zwikszaj stan licznika
     Else
        Licznik_on = 0                                      'kasuj licznik
        Pojemnosc = 0                                       'zeruj licznik pojemnosci
        Licznik_wyjscia = 0
        Portd.0 = 0                                         'wycz przekanik
        Cls
        Display Off                                         'wywietlacz wyczony
        Pwm1a = 0                                           'wywietlacz wygaszony
        Pwm1b = 0                                           'prd zerowy
     End If
     Reset Watchdog
     Reset Plus
     Reset Minus
     Reset Flaga
  End If
Loop
End
'======================================PROCEDURA OBSUGI PRZERWANIA OD TIMERA0====================================================
Przerwanie:                                                 'co 4ms
  Timer0 = Timer0 + 6                                       'zapis aby skruci czas reakcji
  Incr Licznik
  If Licznik = 250 Then                                     'co 1sek
     If Pind.4 = 0 Then Incr Sekundy                        'tylko gdy termik nie zadziaa odliczaj czas
     Flaga = 1
     Licznik = 0
  End If

  If Sekundy = 60 Then : Incr Minuty : Sekundy = 0 : End If
  If Minuty = 60 Then : Incr Godziny : Minuty = 0 : End If

  If Pind.1 = 0 Then                                        'obsuga przycisku impulsatora
     Incr Pomoc_sw                                          'po przytrzymaniu przycisku przez 2s wcz lub wycz urzdzenie
     If Pomoc_sw > 499 Then : Pomoc_sw = 0 : Flaga = 1 : Toggle Power_on : End If
  Else
     Pomoc_sw = 0
  End If

  Select Case Tryb
   Case 0:
    If Pinc.4 = 1 And Pinc.5 = 1 Then Incr Tryb             'obsuga impulsatora
   Case 1:
    If Pinc.4 = 1 And Pinc.5 = 0 Then
       Incr Tryb
       Set Plus
       Set Flaga
    End If
    If Pinc.4 = 0 And Pinc.5 = 1 Then
       Incr Tryb
       Set Minus
       Set Flaga
    End If
   Case 2:
    If Pinc.4 = 1 And Pinc.5 = 1 Then Incr Tryb
   Case 3:
    If Pinc.4 = 1 And Pinc.5 = 0 Then
       Tryb = 0
       Set Plus
       Set Flaga
    End If
    If Pinc.4 = 0 And Pinc.5 = 1 Then
       Tryb = 0
       Set Minus
       Set Flaga
    End If
  End Select
Return